<script setup lang="ts">
import { onMounted, reactive, ref, watch } from "vue";
import { useQuasar, type QTableProps } from "quasar";

import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

import type {
  DataOption,
  ItemsDropdown,
} from "@/modules/06_webservices/interface/index/Main";
import type {
  ResApiName,
  ResApHistory,
} from "@/modules/06_webservices/interface/response/Main";

/** use*/
const $q = useQuasar();
const { showLoader, hideLoader, messageError, date2Thai } = useCounterMixin();

const apiNameId = ref<string>("");
const dataApiName = ref<DataOption[]>([
  {
    id: "",
    name: "ทั้งหมด",
  },
]);
const options = ref<DataOption[]>([]);

const startDate = ref<string>(""); // วันเริ่มต้น
const endDate = ref<string>(""); // วันสินสุด
const startTime = ref<Date | null>(null); // เวลาเริ่มต้น
const endTime = ref<Date | null>(null); //เวลาสินสุด

//รายการค้นหา
const valDropdown = ref<string>("today");
const labelDropdown = ref<string>("วันนี้");
const itemsDropdown = ref<ItemsDropdown[]>([
  {
    labal: "วันนี้",
    val: "today",
  },
  {
    labal: "เมื่อวาน",
    val: "yesterday",
  },
  {
    labal: "ย้อนหลัง 24 ชั่วโมง",
    val: "past24hours",
  },
  {
    labal: "ย้อนหลัง 7 วัน",
    val: "past7days",
  },
  {
    labal: "ย้อนหลัง 30 วัน",
    val: "past30days",
  },
  {
    labal: "กำหนดเอง",
    val: "customized",
  },
]);

const rows = ref<ResApHistory[]>([]);
const visibleColumns = ref<String[]>([
  "apiName",
  "createdAt",
  "apiKey",
  "ipApi",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "apiName",
    align: "left",
    label: "API ที่เข้าถึง",
    sortable: false,
    field: "apiName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่ร้องขอ",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(val, false, true);
    },
  },
  {
    name: "apiKey",
    align: "left",
    label: "ผู้ร้องขอ",
    sortable: false,
    field: "apiKey",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "ipApi",
    align: "left",
    label: " IP Address",
    sortable: false,
    field: "ipApi",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);

/** ฟังก์ชันเรียกรายการข้อมูล API ที่เข้าถึงได้*/
async function fetchListApiKeyName() {
  showLoader();
  http
    .get(config.API.apiKeyMain + "/name")
    .then(async (res) => {
      const data = (await res.data?.result) || [];
      const optionData = data.map((e: ResApiName) => ({
        id: e.id,
        name: e.name,
      }));
      dataApiName.value.push(...optionData);
      options.value = dataApiName.value;
      await onItemClick(labelDropdown.value, valDropdown.value);
      // await fetchListLog();
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function fetchListLog() {
  showLoader();
  http
    .post(config.API.apiKeyMain + `/history`, {
      apiNameId: apiNameId.value,
      endDate: endDate.value,
      startDate: startDate.value,
    })
    .then((res) => {
      rows.value = res.data.result;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

function onSelectType() {
  fetchListLog();
}

/**
 * function ค้นหาคำใน select
 * @param val คำค้นหา
 * @param update function
 * @param type ประเภท select
 */
function filterSelector(val: string, update: Function) {
  update(() => {
    if (val === "") {
      options.value = dataApiName.value;
    } else {
      const newVal = val.toLowerCase();
      options.value = dataApiName.value.filter(
        (v: DataOption) => v.name.toLowerCase().indexOf(newVal) > -1
      );
    }
  });
}

/**
 * เลือกประเภทการค้นหาข้อมูล
 * @param labal ชื่อประเภทการค้นหาข้อมูล
 * @param type ประเภทการค้นหาข้อมูล
 * และค้นหาข้อมูลรายการ Logs ใหม่
 */
async function onItemClick(labal: string, type: string) {
  labelDropdown.value = labal;
  valDropdown.value = type;
  const setDateRange = (daysAgo: number = 0, endOfDay = false) => {
    const date = new Date();
    if (daysAgo) date.setDate(date.getDate() - daysAgo);
    date.setHours(
      endOfDay ? 23 : 0,
      endOfDay ? 59 : 0,
      endOfDay ? 59 : 0,
      endOfDay ? 999 : 0
    );
    return date.toISOString();
  };

  if (type === "today") {
    //วันนี้
    startDate.value = setDateRange(0);
    endDate.value = setDateRange(0, true);
  } else if (type === "yesterday") {
    //เมื่อวาน
    startDate.value = setDateRange(1);
    endDate.value = setDateRange(1, true);
  } else if (type === "past24hours") {
    // ย้อนหลัง 24 ชั่วโมง
    const startDatePast24Hours = new Date();
    startDatePast24Hours.setHours(startDatePast24Hours.getHours() - 24);
    startDate.value = startDatePast24Hours.toISOString();

    // ตั้งค่า endDate เป็นเวลาปัจจุบัน
    endDate.value = new Date().toISOString();
  } else if (["past7days", "past30days"].includes(type)) {
    // ย้อนหลัง 7 วัน และ 30 วัน
    const days = { past7days: 7, past30days: 30 }[type];
    startDate.value = setDateRange(days);
    endDate.value = new Date().toISOString();
  }

  if (type !== "customized") {
    selectedDate();
  } else {
    startTime.value = null;
    endTime.value = null;
  }
}

/**
 * อัปเดทวันที่ต้องการค้นหาข้อมูลรายการ Logs
 * และค้นหาข้อมูลรายการ Logs ใหม่
 */
function updateDate() {
  if (startTime.value && endTime.value) {
    startDate.value = startTime.value.toISOString();
    endDate.value = endTime.value.toISOString();
    selectedDate();
  }
}

/** ฟังก์ชั่นดึงข้อมูลรายการ Logs ตามเงื่อนไข */
function selectedDate() {
  if (!startDate.value) {
    const startDateToday = new Date();
    startDateToday.setHours(0, 0, 0, 0);

    // ตั้งค่า endDate เป็นเวลา 23:59:59 ของวันนี้
    const endDateToday = new Date();
    endDateToday.setHours(23, 59, 59, 999);

    startDate.value = startDateToday.toISOString();
    endDate.value = endDateToday.toISOString();
  }

  fetchListLog();
}

onMounted(async () => {
  await fetchListApiKeyName();
});
</script>

<template>
  <div class="row col-12 q-col-gutter-sm">
    <div class="row col-12">
      <q-btn-dropdown outline color="grey-5" class="full-height">
        <template v-slot:label>
          <div class="row items-center no-wrap">
            <div class="text-black">{{ labelDropdown }}</div>
          </div>
        </template>
        <q-list>
          <q-item
            dense
            v-for="(item, index) in itemsDropdown"
            clickable
            v-close-popup
            @click="onItemClick(item.labal, item.val)"
          >
            <q-item-section>
              <q-item-label>{{ item.labal }}</q-item-label>
            </q-item-section>
          </q-item>
        </q-list>
      </q-btn-dropdown>

      <q-space />

      <q-select
        dense
        style="min-width: 300px"
        hide-bottom-space
        outlined
        option-label="name"
        option-value="id"
        emit-value
        map-options
        v-model="apiNameId"
        :options="options"
        label="รายการ Web Services"
        use-input
        hide-selected
        fill-input
        :clearable="apiNameId !== ''"
        @clear="(apiNameId = ''), (options = dataApiName)"
        @update:modelValue="onSelectType"
        @filter="(inputValue: string,doneFn: Function) => filterSelector(inputValue, doneFn )"
      >
        <template v-slot:no-option>
          <q-item>
            <q-item-section class="text-grey"> ไม่มีข้อมูล </q-item-section>
          </q-item>
        </template>
      </q-select>

      <q-select
        class="q-ml-sm"
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>

    <div v-if="valDropdown === 'customized'" class="row col-12 q-col-gutter-sm">
      <div class="col-2">
        <datepicker
          v-model="startTime"
          :locale="'th'"
          :max-date="endTime"
          selectText="เลือก"
          cancelText="ยกเลิก"
          @update:modelValue="updateDate()"
        >
          <template #year="{ year }">{{ year + 543 }}</template>
          <template #year-overlay-value="{ value }">{{
            parseInt(value + 543)
          }}</template>
          <template #trigger>
            <q-input
              dense
              outlined
              :model-value="
                startTime ? date2Thai(startTime, false, true) : null
              "
              :label="`${'วันเริ่มต้น'}`"
              hide-bottom-space
            >
              <template v-slot:prepend>
                <q-icon
                  name="event"
                  class="cursor-pointer"
                  style="color: var(--q-primary)"
                >
                </q-icon>
              </template>
            </q-input>
          </template>

          <template #action-preview="{ value }">
            {{ date2Thai(value, false, true) }}
          </template>
        </datepicker>
      </div>
      <div class="col-2">
        <datepicker
          v-model="endTime"
          :locale="'th'"
          :enableTimePicker="true"
          selectText="เลือก"
          cancelText="ยกเลิก"
          @update:modelValue="updateDate()"
          :min-date="startTime"
        >
          <template #year="{ year }">{{ year + 543 }}</template>
          <template #year-overlay-value="{ value }">{{
            parseInt(value + 543)
          }}</template>
          <template #trigger>
            <q-input
              dense
              outlined
              :model-value="endTime ? date2Thai(endTime, false, true) : null"
              :label="`${'วันสิ้นสุด'}`"
              hide-bottom-space
            >
              <template v-slot:prepend>
                <q-icon
                  name="event"
                  class="cursor-pointer"
                  style="color: var(--q-primary)"
                >
                </q-icon>
              </template>
            </q-input>
          </template>
          <template #action-preview="{ value }">
            {{ date2Thai(value, false, true) }}
          </template>
        </datepicker>
      </div>
    </div>

    <div class="col-12">
      <d-table
        ref="table"
        :columns="columns"
        :rows="rows"
        row-key="id"
        flat
        bordered
        :paging="true"
        dense
        :rows-per-page-options="[25, 50, 100]"
        :visible-columns="visibleColumns"
      >
        <!-- @update:pagination="updatePagination" -->
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th
              v-for="col in props.cols"
              :key="col.name"
              :props="props"
              style="color: #000000; font-weight: 500"
            >
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
          </q-tr>
        </template>
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td v-for="col in props.cols" :key="col.name" :props="props">
              <div>
                {{ col.value ?? "-" }}
              </div>
            </q-td>
          </q-tr>
        </template>
      </d-table>
    </div>
  </div>
</template>

<style scoped></style>
